module bw_mod_tb();

	reg lcd_clk;
	reg sys_rst_n;
	reg [10:0] img_y;
	reg [10:0] img_cb;
	reg [10:0] img_cr;
	reg pre_frame_de;
	reg [2:0] flag_echo;
	reg [31:0] cnt_back_r;
	wire flag_hand_o;

	//----Code starts here: integrated by Robei-----
	
	initial begin
	lcd_clk <=1;
	sys_rst_n =0;
	#10
	sys_rst_n =1;
	pre_frame_de = 1;
	img_cr = 11'd100;
	img_y = 100;
	img_cb = 180;
	#10 flag_echo = 2;
	cnt_back_r = 6000;
	
	#1000 $finish;
	end
	
	always #10 lcd_clk <= ~lcd_clk;
	
	initial begin
		$dumpfile ("F:/Robei/Robei_tb/vip/bw_mod/bw_mod_tb.vcd");
		$dumpvars;
	end
	//---Module instantiation---
	bw_mod bw_mod1(
		.lcd_clk(lcd_clk),
		.sys_rst_n(sys_rst_n),
		.img_y(img_y),
		.img_cb(img_cb),
		.img_cr(img_cr),
		.pre_frame_de(pre_frame_de),
		.flag_echo(flag_echo),
		.cnt_back_r(cnt_back_r),
		.flag_hand_o(flag_hand_o));

endmodule    //bw_mod_tb

