module bw_mod();


	//----Code starts here: integrated by Robei-----
	
	reg  [2:0]       flag_hand;
	assign flag_hand_o = flag_hand;
	parameter   BWSID			 =  130;	 //二?化阈?，每个4?16进制?1越靠近高位且越多，阈值越小，越容易把暗的数
	parameter  	WHITE            =  16'hffff;	 //白色
	parameter   BLACK			 =  16'h0000;	 //黑色 
	parameter   RED			     =	16'hf800;	 //红色
	parameter   BLUE			 =  16'h0018;	 //蓝色 
	parameter   GRAY			 =  16'h7bef;	 //灰色 
	
	reg	[15:0] sb_ck1;		//边缘?测记录前?个像素点
	reg	[15:0] sb_ck2;		//边缘?测记录后?个像素点
	reg [10:0] x0,x1,y0,y1; 
	reg	[15:0] bw_sb_data_r;
	reg [31:0]	cnt1s,cnt1,cnt_hand;
	reg [31:0] cnt_pixel,t_cnt;				//像素点计数器,总像素计数器
	reg [15:0] pd_data ;
	reg [2:0]  flag_hand_r;				//手形判断中间?
	
	reg [15:0]  bw_data;
	wire	[15:0]	  sb_ck_lin;		//缩边?测传输线，用于将sb_ck2的像素数据传输给sb_ck1
	wire  [31:0]     dtc;				//Ȩ
	wire [15:0] bw_sb_data;
	assign sb_ck_lin  = sb_ck2;		//将缩边检测sb_ck2的数据传给信号线，待会给sb_ck1传输							
	assign bw_sb_data =bw_sb_data_r ;		// 
	assign dtc = 10000 -cnt_back_r;
	
	always@ (posedge lcd_clk or negedge sys_rst_n) begin
		if (!sys_rst_n) begin
		cnt_pixel <= 32'd0;
		flag_hand_r <= 3'd0;
		end
		else begin//(img_cb > 78) && (img_cb < 125) && (img_cr > 140) && (img_cr < 160)
		if ((img_cb > 77) && (img_cb < 127) && (img_cr > 133) && (img_cr < 173)) begin	//
				bw_data <= WHITE;
				sb_ck2 <= WHITE;	
				cnt_pixel <= cnt_pixel + 1;		//像素点计?
				if (cnt_pixel >= 10000  && cnt_pixel <= 25000 ) begin			//- (cnt_back)+ dtc
				flag_hand_r <= 3'd1;
				end
				if (cnt_pixel >= 26000   && cnt_pixel <= 60000  ) begin
					flag_hand_r <= 3'd2;
				end	
				if (cnt_pixel >= 60000   && cnt_pixel <= 28000000  ) begin		// && cnt_pixel <= 999900
					flag_hand_r <= 3'd3;
				end
			end
			else begin
				bw_data <= BLACK;
				sb_ck2 <= BLACK;	
			end
		if(sb_ck1 != sb_ck2) begin		//如果前后两个二?化后的像素颜色不一样，说明在边缘，就执行边缘显?
				bw_sb_data_r <= WHITE;	
				
				end
		else begin 	
				bw_sb_data_r <= BLACK;			
			end
			
			if (t_cnt == 32'd0) begin
				cnt_pixel <= 32'd0;
				//flag_hand_r <= 3'd0;
			end
		end
	end
	//*******************手形多模块融合判?***********************//
	always @(posedge lcd_clk or negedge sys_rst_n) begin
		if (!sys_rst_n) begin
		flag_hand <= 3'd0;
		cnt_hand <= 32'd0;
		end
		else begin
		if (flag_hand != flag_hand_r ) begin	//&& t_cnt == 32'd0
		   cnt_hand <= cnt_hand +1;
			if (cnt_hand >= 10000) begin
				flag_hand <= flag_hand_r;
				cnt_hand <= 32'd0;
			end
		end
		else begin
			cnt_hand <= 32'd0;
		end
		if (t_cnt == 130560-1 )	begin
		     flag_hand <= 3'd0;
		end
	end
	end
	
	
	always@ (posedge lcd_clk or negedge sys_rst_n) begin		//sb_ck1和sb_ck2之间延迟?个时钟达成两个分别记录前后两个像素点数据的效?
		if(!sys_rst_n) begin
			sb_ck1 <= 16'b0;			
		end	
		else begin
			sb_ck1 <= sb_ck_lin;
		end
	end
	
	//?帧?像素点计数?
	always@ (posedge lcd_clk or negedge sys_rst_n) begin
		if(!sys_rst_n) 
			t_cnt <= 32'd0;
		else if(pre_frame_de)begin
			if(t_cnt == 130560-1) 			//标准?帧的像素点个数！！！！！
					t_cnt <= 32'd0;			
			else
				t_cnt <= t_cnt + 1'd1;           
		end
	end
	
	
	
	
endmodule    //bw_mod

