module color_if_tb();

	reg sys_clk;
	reg sys_rst_n;
	reg pre_frame_de;
	reg car_move_flag;
	reg [7:0] img_y;
	reg [7:0] img_cb;
	reg [7:0] img_cr;
	wire cross_flag;
	wire [2:0] what_color;
	wire [10:0] x_com;
	wire [10:0] y_com;
	wire [2:0] flag_size;
	wire [31:0] y1;
	wire [31:0] y1_r;

	//----Code starts here: integrated by Robei-----
	initial begin
		sys_clk = 1;
		sys_rst_n = 0;
	#10 sys_rst_n = 1;
	pre_frame_de = 1;
	img_y = 100;
	img_cb= 180;
	img_cr = 180;
	#100000 $finish;
	end
	always #1 sys_clk <=~sys_clk;
	
	always @(sys_clk) begin
		if (img_cr<190) begin
	
			img_cr <= img_cr +1;
		end
		else begin
	
			img_cr <= 170;
		end
	end
	
	initial begin
		$dumpfile ("F:/Robei/Robei_tb/vip/color_if/color_if_tb.vcd");
		$dumpvars;
	end
	//---Module instantiation---
	color_if color_if1(
		.sys_clk(sys_clk),
		.sys_rst_n(sys_rst_n),
		.pre_frame_de(pre_frame_de),
		.car_move_flag(car_move_flag),
		.img_y(img_y),
		.img_cb(img_cb),
		.img_cr(img_cr),
		.cross_flag(cross_flag),
		.what_color(what_color),
		.x_com(x_com),
		.y_com(y_com),
		.flag_size(flag_size),
		.y1(y1),
		.y1_r(y1_r));

endmodule    //color_if_tb

